---
title: Update a notification rule
description: Datadog, the leading service for cloud-scale monitoring.
breadcrumbs: Docs > API Reference > Case Management
---

# Update a notification rule{% #update-a-notification-rule %}
Copy pageCopied
{% tab title="v2" %}

| Datadog site      | API endpoint                                                                                                   |
| ----------------- | -------------------------------------------------------------------------------------------------------------- |
| ap1.datadoghq.com | PUT https://api.ap1.datadoghq.com/api/v2/cases/projects/{project_id}/notification_rules/{notification_rule_id} |
| ap2.datadoghq.com | PUT https://api.ap2.datadoghq.com/api/v2/cases/projects/{project_id}/notification_rules/{notification_rule_id} |
| app.datadoghq.eu  | PUT https://api.datadoghq.eu/api/v2/cases/projects/{project_id}/notification_rules/{notification_rule_id}      |
| app.ddog-gov.com  | PUT https://api.ddog-gov.com/api/v2/cases/projects/{project_id}/notification_rules/{notification_rule_id}      |
| us2.ddog-gov.com  | PUT https://api.us2.ddog-gov.com/api/v2/cases/projects/{project_id}/notification_rules/{notification_rule_id}  |
| app.datadoghq.com | PUT https://api.datadoghq.com/api/v2/cases/projects/{project_id}/notification_rules/{notification_rule_id}     |
| us3.datadoghq.com | PUT https://api.us3.datadoghq.com/api/v2/cases/projects/{project_id}/notification_rules/{notification_rule_id} |
| us5.datadoghq.com | PUT https://api.us5.datadoghq.com/api/v2/cases/projects/{project_id}/notification_rules/{notification_rule_id} |

### Overview

Update a notification rule.

OAuth apps require the `cases_write` authorization [scope](https://docs.datadoghq.com/api/latest/scopes.md#case-management) to access this endpoint.



### Arguments

#### Path Parameters

| Name                                   | Type   | Description            |
| -------------------------------------- | ------ | ---------------------- |
| project_id [*required*]           | string | Project UUID           |
| notification_rule_id [*required*] | string | Notification Rule UUID |

### Request

#### Body Data (required)

Notification rule payload

{% tab title="Model" %}

| Parent field | Field                  | Type     | Description                                                                                                       |
| ------------ | ---------------------- | -------- | ----------------------------------------------------------------------------------------------------------------- |
|              | data [*required*] | object   | Notification rule update                                                                                          |
| data         | attributes             | object   | Notification rule attributes                                                                                      |
| attributes   | is_enabled             | boolean  | Whether the notification rule is enabled                                                                          |
| attributes   | query                  | string   | Query to filter cases for this notification rule                                                                  |
| attributes   | recipients             | [object] | List of notification recipients                                                                                   |
| recipients   | data                   | object   | Recipient data                                                                                                    |
| data         | channel                | string   | Slack channel name                                                                                                |
| data         | channel_id             | string   | Slack channel ID                                                                                                  |
| data         | channel_name           | string   | Microsoft Teams channel name                                                                                      |
| data         | connector_name         | string   | Microsoft Teams connector name                                                                                    |
| data         | email                  | string   | Email address                                                                                                     |
| data         | name                   | string   | HTTP webhook name                                                                                                 |
| data         | service_name           | string   | PagerDuty service name                                                                                            |
| data         | team_id                | string   | Microsoft Teams team ID                                                                                           |
| data         | team_name              | string   | Microsoft Teams team name                                                                                         |
| data         | tenant_id              | string   | Microsoft Teams tenant ID                                                                                         |
| data         | tenant_name            | string   | Microsoft Teams tenant name                                                                                       |
| data         | workspace              | string   | Slack workspace name                                                                                              |
| data         | workspace_id           | string   | Slack workspace ID                                                                                                |
| recipients   | type                   | string   | Type of recipient (SLACK_CHANNEL, EMAIL, HTTP, PAGERDUTY_SERVICE, MS_TEAMS_CHANNEL)                               |
| attributes   | triggers               | [object] | List of triggers for this notification rule                                                                       |
| triggers     | data                   | object   | Trigger data                                                                                                      |
| data         | change_type            | string   | Change type (added, removed, changed)                                                                             |
| data         | field                  | string   | Field name for attribute value changed trigger                                                                    |
| data         | from_status            | string   | Status ID to transition from                                                                                      |
| data         | from_status_name       | string   | Status name to transition from                                                                                    |
| data         | to_status              | string   | Status ID to transition to                                                                                        |
| data         | to_status_name         | string   | Status name to transition to                                                                                      |
| triggers     | type                   | string   | Type of trigger (CASE_CREATED, STATUS_TRANSITIONED, ATTRIBUTE_VALUE_CHANGED, EVENT_CORRELATION_SIGNAL_CORRELATED) |
| data         | type [*required*] | enum     | Notification rule resource type Allowed enum values: `notification_rule`                                          |

{% /tab %}

{% tab title="Example" %}

```json
{
  "data": {
    "attributes": {
      "is_enabled": false,
      "query": "string",
      "recipients": [
        {
          "data": {
            "channel": "string",
            "channel_id": "string",
            "channel_name": "string",
            "connector_name": "string",
            "email": "string",
            "name": "string",
            "service_name": "string",
            "team_id": "string",
            "team_name": "string",
            "tenant_id": "string",
            "tenant_name": "string",
            "workspace": "string",
            "workspace_id": "string"
          },
          "type": "EMAIL"
        }
      ],
      "triggers": [
        {
          "data": {
            "change_type": "string",
            "field": "string",
            "from_status": "string",
            "from_status_name": "string",
            "to_status": "string",
            "to_status_name": "string"
          },
          "type": "CASE_CREATED"
        }
      ]
    },
    "type": "notification_rule"
  }
}
```

{% /tab %}

### Response

{% tab title="204" %}
No Content
{% /tab %}

{% tab title="400" %}
Bad Request
{% tab title="Model" %}
API error response.

| Field                    | Type     | Description       |
| ------------------------ | -------- | ----------------- |
| errors [*required*] | [string] | A list of errors. |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    "Bad Request"
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="401" %}
Unauthorized
{% tab title="Model" %}
API error response.

| Field                    | Type     | Description       |
| ------------------------ | -------- | ----------------- |
| errors [*required*] | [string] | A list of errors. |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    "Bad Request"
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="403" %}
Forbidden
{% tab title="Model" %}
API error response.

| Field                    | Type     | Description       |
| ------------------------ | -------- | ----------------- |
| errors [*required*] | [string] | A list of errors. |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    "Bad Request"
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="404" %}
Not Found
{% tab title="Model" %}
API error response.

| Field                    | Type     | Description       |
| ------------------------ | -------- | ----------------- |
| errors [*required*] | [string] | A list of errors. |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    "Bad Request"
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="429" %}
Too many requests
{% tab title="Model" %}
API error response.

| Field                    | Type     | Description       |
| ------------------------ | -------- | ----------------- |
| errors [*required*] | [string] | A list of errors. |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    "Bad Request"
  ]
}
```

{% /tab %}

{% /tab %}

### Code Example

##### 
                  \## default
# 
 \# Path parameters export project_id="e555e290-ed65-49bd-ae18-8acbfcf18db7" export notification_rule_id="e555e290-ed65-49bd-ae18-8acbfcf18db7" \# Curl command curl -X PUT "https://api.datadoghq.com/api/v2/cases/projects/${project_id}/notification_rules/${notification_rule_id}" \
-H "Content-Type: application/json" \
-H "DD-API-KEY: ${DD_API_KEY}" \
-H "DD-APPLICATION-KEY: ${DD_APP_KEY}" \
-d @- << EOF
{
  "data": {
    "attributes": {
      "recipients": [
        {
          "type": "EMAIL"
        }
      ],
      "triggers": [
        {
          "type": "CASE_CREATED"
        }
      ]
    },
    "type": "notification_rule"
  }
}
EOF 
                
##### 

```python
"""
Update a notification rule returns "No Content" response
"""

from datadog_api_client import ApiClient, Configuration
from datadog_api_client.v2.api.case_management_api import CaseManagementApi
from datadog_api_client.v2.model.case_notification_rule_attributes import CaseNotificationRuleAttributes
from datadog_api_client.v2.model.case_notification_rule_recipient import CaseNotificationRuleRecipient
from datadog_api_client.v2.model.case_notification_rule_recipient_data import CaseNotificationRuleRecipientData
from datadog_api_client.v2.model.case_notification_rule_resource_type import CaseNotificationRuleResourceType
from datadog_api_client.v2.model.case_notification_rule_trigger import CaseNotificationRuleTrigger
from datadog_api_client.v2.model.case_notification_rule_trigger_data import CaseNotificationRuleTriggerData
from datadog_api_client.v2.model.case_notification_rule_update import CaseNotificationRuleUpdate
from datadog_api_client.v2.model.case_notification_rule_update_request import CaseNotificationRuleUpdateRequest

body = CaseNotificationRuleUpdateRequest(
    data=CaseNotificationRuleUpdate(
        attributes=CaseNotificationRuleAttributes(
            recipients=[
                CaseNotificationRuleRecipient(
                    data=CaseNotificationRuleRecipientData(),
                    type="EMAIL",
                ),
            ],
            triggers=[
                CaseNotificationRuleTrigger(
                    data=CaseNotificationRuleTriggerData(),
                    type="CASE_CREATED",
                ),
            ],
        ),
        type=CaseNotificationRuleResourceType.NOTIFICATION_RULE,
    ),
)

configuration = Configuration()
with ApiClient(configuration) as api_client:
    api_instance = CaseManagementApi(api_client)
    api_instance.update_project_notification_rule(
        project_id="project_id", notification_rule_id="notification_rule_id", body=body
    )
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=python) and then save the example to `example.py` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" python3 "example.py"
##### 

```ruby
# Update a notification rule returns "No Content" response

require "datadog_api_client"
api_instance = DatadogAPIClient::V2::CaseManagementAPI.new

body = DatadogAPIClient::V2::CaseNotificationRuleUpdateRequest.new({
  data: DatadogAPIClient::V2::CaseNotificationRuleUpdate.new({
    attributes: DatadogAPIClient::V2::CaseNotificationRuleAttributes.new({
      recipients: [
        DatadogAPIClient::V2::CaseNotificationRuleRecipient.new({
          data: DatadogAPIClient::V2::CaseNotificationRuleRecipientData.new({}),
          type: "EMAIL",
        }),
      ],
      triggers: [
        DatadogAPIClient::V2::CaseNotificationRuleTrigger.new({
          data: DatadogAPIClient::V2::CaseNotificationRuleTriggerData.new({}),
          type: "CASE_CREATED",
        }),
      ],
    }),
    type: DatadogAPIClient::V2::CaseNotificationRuleResourceType::NOTIFICATION_RULE,
  }),
})
api_instance.update_project_notification_rule("project_id", "notification_rule_id", body)
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=ruby) and then save the example to `example.rb` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" rb "example.rb"
##### 

```go
// Update a notification rule returns "No Content" response

package main

import (
	"context"
	"fmt"
	"os"

	"github.com/DataDog/datadog-api-client-go/v2/api/datadog"
	"github.com/DataDog/datadog-api-client-go/v2/api/datadogV2"
)

func main() {
	body := datadogV2.CaseNotificationRuleUpdateRequest{
		Data: datadogV2.CaseNotificationRuleUpdate{
			Attributes: &datadogV2.CaseNotificationRuleAttributes{
				Recipients: []datadogV2.CaseNotificationRuleRecipient{
					{
						Data: &datadogV2.CaseNotificationRuleRecipientData{},
						Type: datadog.PtrString("EMAIL"),
					},
				},
				Triggers: []datadogV2.CaseNotificationRuleTrigger{
					{
						Data: &datadogV2.CaseNotificationRuleTriggerData{},
						Type: datadog.PtrString("CASE_CREATED"),
					},
				},
			},
			Type: datadogV2.CASENOTIFICATIONRULERESOURCETYPE_NOTIFICATION_RULE,
		},
	}
	ctx := datadog.NewDefaultContext(context.Background())
	configuration := datadog.NewConfiguration()
	apiClient := datadog.NewAPIClient(configuration)
	api := datadogV2.NewCaseManagementApi(apiClient)
	r, err := api.UpdateProjectNotificationRule(ctx, "project_id", "notification_rule_id", body)

	if err != nil {
		fmt.Fprintf(os.Stderr, "Error when calling `CaseManagementApi.UpdateProjectNotificationRule`: %v\n", err)
		fmt.Fprintf(os.Stderr, "Full HTTP response: %v\n", r)
	}
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=go) and then save the example to `main.go` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" go run "main.go"
##### 

```java
// Update a notification rule returns "No Content" response

import com.datadog.api.client.ApiClient;
import com.datadog.api.client.ApiException;
import com.datadog.api.client.v2.api.CaseManagementApi;
import com.datadog.api.client.v2.model.CaseNotificationRuleAttributes;
import com.datadog.api.client.v2.model.CaseNotificationRuleRecipient;
import com.datadog.api.client.v2.model.CaseNotificationRuleRecipientData;
import com.datadog.api.client.v2.model.CaseNotificationRuleResourceType;
import com.datadog.api.client.v2.model.CaseNotificationRuleTrigger;
import com.datadog.api.client.v2.model.CaseNotificationRuleTriggerData;
import com.datadog.api.client.v2.model.CaseNotificationRuleUpdate;
import com.datadog.api.client.v2.model.CaseNotificationRuleUpdateRequest;
import java.util.Collections;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = ApiClient.getDefaultApiClient();
    CaseManagementApi apiInstance = new CaseManagementApi(defaultClient);

    CaseNotificationRuleUpdateRequest body =
        new CaseNotificationRuleUpdateRequest()
            .data(
                new CaseNotificationRuleUpdate()
                    .attributes(
                        new CaseNotificationRuleAttributes()
                            .recipients(
                                Collections.singletonList(
                                    new CaseNotificationRuleRecipient()
                                        .data(new CaseNotificationRuleRecipientData())
                                        .type("EMAIL")))
                            .triggers(
                                Collections.singletonList(
                                    new CaseNotificationRuleTrigger()
                                        .data(new CaseNotificationRuleTriggerData())
                                        .type("CASE_CREATED"))))
                    .type(CaseNotificationRuleResourceType.NOTIFICATION_RULE));

    try {
      apiInstance.updateProjectNotificationRule(
          "e555e290-ed65-49bd-ae18-8acbfcf18db7", "e555e290-ed65-49bd-ae18-8acbfcf18db7", body);
    } catch (ApiException e) {
      System.err.println("Exception when calling CaseManagementApi#updateProjectNotificationRule");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=java) and then save the example to `Example.java` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" java "Example.java"
##### 

```rust
// Update a notification rule returns "No Content" response
use datadog_api_client::datadog;
use datadog_api_client::datadogV2::api_case_management::CaseManagementAPI;
use datadog_api_client::datadogV2::model::CaseNotificationRuleAttributes;
use datadog_api_client::datadogV2::model::CaseNotificationRuleRecipient;
use datadog_api_client::datadogV2::model::CaseNotificationRuleRecipientData;
use datadog_api_client::datadogV2::model::CaseNotificationRuleResourceType;
use datadog_api_client::datadogV2::model::CaseNotificationRuleTrigger;
use datadog_api_client::datadogV2::model::CaseNotificationRuleTriggerData;
use datadog_api_client::datadogV2::model::CaseNotificationRuleUpdate;
use datadog_api_client::datadogV2::model::CaseNotificationRuleUpdateRequest;

#[tokio::main]
async fn main() {
    let body = CaseNotificationRuleUpdateRequest::new(
        CaseNotificationRuleUpdate::new(CaseNotificationRuleResourceType::NOTIFICATION_RULE)
            .attributes(
                CaseNotificationRuleAttributes::new()
                    .recipients(vec![CaseNotificationRuleRecipient::new()
                        .data(CaseNotificationRuleRecipientData::new())
                        .type_("EMAIL".to_string())])
                    .triggers(vec![CaseNotificationRuleTrigger::new()
                        .data(CaseNotificationRuleTriggerData::new())
                        .type_("CASE_CREATED".to_string())]),
            ),
    );
    let configuration = datadog::Configuration::new();
    let api = CaseManagementAPI::with_config(configuration);
    let resp = api
        .update_project_notification_rule(
            "project_id".to_string(),
            "notification_rule_id".to_string(),
            body,
        )
        .await;
    if let Ok(value) = resp {
        println!("{:#?}", value);
    } else {
        println!("{:#?}", resp.unwrap_err());
    }
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=rust) and then save the example to `src/main.rs` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" cargo run
##### 

```typescript
/**
 * Update a notification rule returns "No Content" response
 */

import { client, v2 } from "@datadog/datadog-api-client";

const configuration = client.createConfiguration();
const apiInstance = new v2.CaseManagementApi(configuration);

const params: v2.CaseManagementApiUpdateProjectNotificationRuleRequest = {
  body: {
    data: {
      attributes: {
        recipients: [
          {
            data: {},
            type: "EMAIL",
          },
        ],
        triggers: [
          {
            data: {},
            type: "CASE_CREATED",
          },
        ],
      },
      type: "notification_rule",
    },
  },
  projectId: "project_id",
  notificationRuleId: "notification_rule_id",
};

apiInstance
  .updateProjectNotificationRule(params)
  .then((data: any) => {
    console.log(
      "API called successfully. Returned data: " + JSON.stringify(data)
    );
  })
  .catch((error: any) => console.error(error));
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=typescript) and then save the example to `example.ts` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" tsc "example.ts"
{% /tab %}
